

public class SDESAlgorithm {

    final int p10[] = {3, 5, 2, 7, 4, 10, 1, 9, 8, 6};
    final int p8[] = {6, 3, 7, 4, 8, 5, 10, 9};
    final int p4[] = {2, 4, 3, 1};
    final int ip[] = {2, 6, 3, 1, 4, 8, 5, 7};
    final int ep[] = {4, 1, 2, 3, 2, 3, 4, 1};
    final int ipInverse[] = {4, 1, 3, 5, 7, 2, 8, 6};
    final int s0[][] = {{1, 0, 3, 2}, {3, 2, 1, 0}, {0, 2, 1, 3}, {3, 1, 3, 2}};
    final int s1[][] = {{0, 1, 2, 3}, {2, 0, 1, 3}, {3, 0, 1, 0}, {2, 1, 0, 3}};
    String key;
    String k1, k2;
    String plainText;
    String cipherText;

    SDESAlgorithm(String input, String key, boolean encrypted) {
        this.key = key;
        keyGeneration();
        if (encrypted) {
            this.cipherText = input;
        } else {
            this.plainText = input;
        }

    }

    String ip(String input) {
        String ans = permutation(input, this.ip);
        return ans;
    }

    String ep(String input) {
        String ans = permutation(input, this.ep);
        return ans;
    }

    String ipInverse(String input) {
        String ans = permutation(input, this.ipInverse);
        return ans;
    }

    String p4(String input) {
        String ans = permutation(input, this.p4);
        return ans;
    }

    String p8(String input) {
        String ans = permutation(input, this.p8);
        return ans;
    }

    String p10(String input) {
        String ans = permutation(input, this.p10);
        return ans;
    }

    String s0(String input) {
        String ans = substitution(input, this.s0);
        return ans;
    }

    String s1(String input) {
        String ans = substitution(input, this.s1);
        return ans;
    }

    String permutation(String input, int[] permutation) {
        int l = permutation.length;
        String ans = "";
        for (int i = 0; i < l; i++) {
            ans = ans + Character.toString(input.charAt((permutation[i] - 1)));
        }
        return ans;
    }

    String substitution(String input, int[][] substitute) {
        String ans = "";
        int row = Integer.parseInt((input.substring(0, 1) + input.substring(3)), 2);
        int col = Integer.parseInt(input.substring(1, 3), 2);
        ans = Integer.toBinaryString(substitute[row][col]);
        if (ans.length() == 1) {
            ans = "0" + ans;
        }
        return ans;
    }

    String lcs(String input, int n) {
        String ans = "";
        ans = ans + input.substring(n);
        ans = ans + input.substring(0, n);
        return ans;
    }

    String exor(String input1, String input2) {

        String ans = "";
        int t = input1.length();
        for (int i = 0; i < t; i++) {

            if (input1.charAt(i) == input2.charAt(i)) {
                ans = ans + "0";
            } else {
                ans = ans + "1";
            }
        }
        return ans;
    }

    void keyGeneration() {
        String p10Output = p10(key);
        String lcs1Output1 = lcs(p10Output.substring(0, 5), 1);
        String lcs1Output2 = lcs(p10Output.substring(5), 1);
        String p8Output1 = p8(lcs1Output1 + lcs1Output2);
        this.k1 = p8Output1;
        String lcs2Output1 = lcs(lcs1Output1, 2);
        String lcs2Output2 = lcs(lcs1Output2, 2);
        String p8Output2 = p8(lcs2Output1 + lcs2Output2);
        this.k2 = p8Output2;
        System.out.println("k1=" + this.k1 + " k2=" + this.k2);
    }

    String fk(String input, String key) {
        String ans = "";
        String epOutput = ep(input.substring(4));
        String exorOutput1 = exor(epOutput, key);
        String s0Output = s0(exorOutput1.substring(0, 4));
        String s1Output = s1(exorOutput1.substring(4));
        String p4Output = p4(s0Output + s1Output);
        String exorOutput2 = exor(p4Output, input.substring(0, 4));
        ans = exorOutput2;
        return ans;
    }

    String encrypt() {
        String ipOutput = ip(this.plainText);
        String fkOutput1 = fk(ipOutput, this.k1);
        String fkOutput2 = fk((ipOutput.substring(4) + fkOutput1.substring(0, 4)), this.k2);
        String ipInverseOutput = ipInverse(fkOutput2 + fkOutput1.substring(0, 4));
        this.cipherText = ipInverseOutput;
        return cipherText;
    }

    String decrypt() {
        String ipOutput = ip(this.cipherText);
        String fkOutput1 = fk(ipOutput, this.k2);
        String fkOutput2 = fk((ipOutput.substring(4) + fkOutput1.substring(0, 4)), this.k1);
        String ipInverseOutput = ipInverse(fkOutput2 + fkOutput1.substring(0, 4));
        String ansPlainText = ipInverseOutput;
        return ansPlainText;
    }
}

